
/*	Copyright (C) 2005, 2006 by Andy Grebe a.k.a. tecknophreak(tecknophreak@gmail.com)
 *
 *	This file is part of TouchMe Games.
 *
 *	TouchMe Games is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	TouchMe Games is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with TouchMe Games; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 

// events for DartTicTacToe

#include <darttictactoe.h>
#include <algorithm>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <termios.h>
#include <unistd.h>

void DartTicTacToe::exitGame(GtkWidget *widget, GdkEvent *event, gpointer ptr) {
	DartTicTacToe *g(reinterpret_cast<DartTicTacToe *>(ptr));
	SCORE_STRUCT newScore;
	
//	newScore.name = "";
//	newScore.score = g->finalScore[g->winner];
//	newScore.date = "";
	
//	g->GAME_PTR::addScore(g->scores, newScore);
	
	
//	g->GAME_PTR::saveScores(g->scores);
	
	gtk_widget_hide(g->fixed);
	
	g_source_remove(g->timer);
	
	g->dartBoard.closeDart();
}

bool DartTicTacToe::checkForWinner(char ch) {
	// check across row
	std::cout << "Check for winner" << std::endl;
	std::cout.flush();
	for (int x = 0; x < 3; ++x) {
		bool winner(true);
		for (int y = 0; y < 3; ++y) {
			if (tttDoneLabels[x][y] == NULL) {
				winner = false;
			}
			if (tttDoneLabels[x][y] != NULL && gtk_label_get_text((GtkLabel *)tttDoneLabels[x][y])[0] != ch) {
				winner = false;
			}
		}
		if (winner) {
			std::cout << "True " << __LINE__ << std::endl;
			return true;
		}
	}
	// check down row
	for (int y = 0; y < 3; ++y) {
		bool winner(true);
		for (int x = 0; x < 3; ++x) {
			if (tttDoneLabels[x][y] == NULL) {
				winner = false;
			}
			if (tttDoneLabels[x][y] != NULL && gtk_label_get_text((GtkLabel *)tttDoneLabels[x][y])[0] != ch) {
				winner = false;
			}
		}
		if (winner) {
			std::cout << "True " << __LINE__ << std::endl;
			return true;
		}
	}
	// check left horizontal
	if ((tttDoneLabels[0][0] != NULL && gtk_label_get_text((GtkLabel *)tttDoneLabels[0][0])[0] == ch)
		    && (tttDoneLabels[1][1] != NULL && gtk_label_get_text((GtkLabel *)tttDoneLabels[1][1])[0] == ch)
		    && (tttDoneLabels[2][2] != NULL && gtk_label_get_text((GtkLabel *)tttDoneLabels[2][2])[0] == ch)) {
		std::cout << "True " << __LINE__ << std::endl;
		return true;
	}
	
	// check right horizontal
	if ((tttDoneLabels[0][2] != NULL && gtk_label_get_text((GtkLabel *)tttDoneLabels[0][2])[0] == ch)
		    && (tttDoneLabels[1][1] != NULL && gtk_label_get_text((GtkLabel *)tttDoneLabels[1][1])[0] == ch)
		    && (tttDoneLabels[2][0] != NULL && gtk_label_get_text((GtkLabel *)tttDoneLabels[2][0])[0] == ch)) {
		std::cout << "True " << __LINE__ << std::endl;
		return true;
	}
	return false;
}

gboolean DartTicTacToe::timeout(gpointer ptr) {
	DartTicTacToe *dart(reinterpret_cast<DartTicTacToe *>(ptr));
	int score;
	std::stringstream sstr;
	
	
	if (dart->currentDart <= 2) {
		int a, x(0);
		if (!dart->dartBoard.gotDart()) {
			return TRUE;
		}
		dart->dartBoard.readDart(x, a);
		
		if (a == 2) {
			++dart->doubles[dart->currentPlayer];
		}
		else if (a == 3) {
			++dart->triples[dart->currentPlayer];
		}
		
		if (x > 20) {
//			++dart->bulls[dart->currentPlayer];
		}
		
		score = x * a;
		
		
		// Incoming dart
		++dart->darts[dart->currentPlayer];
		
		sstr.str("");
		if (a == 1) {
			sstr << "Single ";
			if (x < 25) {
				sstr << score;
			}
			else {
				sstr << "BULL";
			}
		}
		else if (a == 2) {
			sstr << "Double ";
			if (x < 25) {
				sstr << score / a;
			}
			else {
				sstr << "BULL";
			}
		}
		else if (a == 3) {
			sstr << "Triple " << score / a;
			
		}
		gtk_label_set_text((GtkLabel *)dart->dartLabels[dart->currentDart], sstr.str().c_str());
		gtk_widget_show(dart->dartLabels[dart->currentDart]);
		gtk_widget_hide(dart->dartImages[dart->currentDart]);
		
		for (int i = 0; i < 9; ++i) {
			if (x == dart->marks[i]) {
				std::string str;
				int marks(0);
				if (dart->tttlabels[i / 3][i % 3][dart->currentPlayer] == NULL) {
					++dart->currentDart;
					return TRUE;
				}
				str = gtk_label_get_text((GtkLabel *)dart->tttlabels[i / 3][i % 3][dart->currentPlayer]);
				if (dart->currentPlayer) {
					marks = std::count(str.begin(), str.end(), 'O');
				}
				else {
					marks = std::count(str.begin(), str.end(), 'X');
				}
				if (marks + a < 4) {
					sstr.str("");
					for (int j = 0; j < marks + a; ++j) {
						if (dart->currentPlayer) {
							sstr << 'O';
						}
						else {
							sstr << 'X';
						}
					}
					gtk_label_set_text((GtkLabel *)dart->tttlabels[i / 3][i % 3][dart->currentPlayer],
						sstr.str().c_str());
					std::cout << "Marks before 1 "
							<< dart->playerMarks[dart->currentPlayer]
							<< std::endl;
					dart->playerMarks[dart->currentPlayer] += a;
					std::cout << "Marks after 1 "
							<< dart->playerMarks[dart->currentPlayer]
							<< std::endl;
				}
				else {
					GtkRcStyle *rcstyle;
					if (dart->tttDoneLabels[i / 3][i % 3] == NULL) {
						std::cout << "Marks before 2 "
								<< dart->playerMarks[dart->currentPlayer]
								<< std::endl;
						dart->playerMarks[dart->currentPlayer] += 4 - marks;
						std::cout << "Marks after 2 "
								<< dart->playerMarks[dart->currentPlayer]
								<< std::endl;
					}
					dart->tttDoneLabels[i / 3][i % 3] = gtk_label_new(dart->currentPlayer ? "O": "X");
					rcstyle = gtk_rc_style_new();
					rcstyle->font_desc = pango_font_description_new();
					pango_font_description_set_size(rcstyle->font_desc, 60 * PANGO_SCALE);
					pango_font_description_set_weight(rcstyle->font_desc, PANGO_WEIGHT_BOLD);
					gtk_widget_modify_style(dart->tttDoneLabels[i / 3][i % 3], rcstyle);
					gtk_widget_destroy(dart->tttvboxes[i / 3][i % 3]);
					gtk_table_attach_defaults((GtkTable *)dart->ttttable, 
							dart->tttDoneLabels[i / 3][i % 3], i / 3, i / 3 + 1,
							i % 3, (i % 3) + 1);
					gtk_widget_show(dart->tttDoneLabels[i / 3][i % 3]);
					dart->tttlabels[i / 3][i % 3][0] = NULL;
					dart->tttlabels[i / 3][i % 3][1] = NULL;
					if (dart->checkForWinner((dart->currentPlayer ? 'O': 'X'))) {
						dart->winner = dart->currentPlayer;
						dart->createGameOver1();
						return FALSE;
					}
     pango_font_description_free(rcstyle->font_desc);
				}
				i = 9;
			}
		}
		++dart->currentDart;
		
	}
	else {
		if (dart->currentDart == 3) {
			int player;
			float mpr(0.0);
			dart->dartBoard.pause();
			// MPR Above each player's score
			++dart->rounds[dart->currentPlayer];
			player = dart->currentPlayer;
			
			
			if (dart->darts[player]) {
				mpr = (float)(dart->playerMarks[player]) / (float)(dart->rounds[player]);
			}
			else {
				mpr = 0.0;
			}
			
			sstr.str("");
			sstr << "Player " << player + 1 << " - " << std::setprecision(3) << mpr;
			gtk_label_set_text((GtkLabel *)dart->playerLabels[player], sstr.str().c_str());

		}
		else if (dart->currentDart == 23) {
			int player;
			float mpr(0.0);
			
			// get the next player's MPR going
			if (dart->currentPlayer + 1 == 2) {
				player = 0;
				std::cout << "Round " << dart->round << std::endl;
			}
			else {
				player = dart->currentPlayer + 1;
			}
			
			
			
			if (dart->darts[player]) {
				mpr = (float)(dart->playerMarks[player]) / (float)(dart->rounds[player]);
			}
			else {
				mpr = 0.0;
			}
			
			sstr.str("");
			sstr << "Player " << player + 1;
			gtk_label_set_text((GtkLabel *)dart->mprPlayerLabel, sstr.str().c_str());
			
			sstr.str("");
			sstr << "MPR: " << std::setprecision(3) << mpr;
			
			gtk_label_set_text((GtkLabel *)dart->mprLabel, sstr.str().c_str());
			
			gtk_widget_show_all(dart->mprWindow);
			
		}

		++dart->currentDart;
	}
	if (dart->currentDart == 73) {
		dart->currentDart = 0;
		gtk_widget_show(dart->dartImages[0]);
		gtk_widget_show(dart->dartImages[1]);
		gtk_widget_show(dart->dartImages[2]);
		gtk_widget_hide(dart->dartLabels[0]);
		gtk_widget_hide(dart->dartLabels[1]);
		gtk_widget_hide(dart->dartLabels[2]);
		
		
		if (++dart->currentPlayer == 2) {
			dart->currentPlayer = 0;
			++dart->round;
			sstr.str("");
			sstr << "Round " << std::setw(3) << dart->round;
			gtk_label_set_text((GtkLabel *)dart->roundLabel, sstr.str().c_str());
			
		}
		if (dart->currentPlayer == 0) {
			gtk_widget_modify_style(dart->playerEvent[0], dart->selectScoreBg);
			gtk_widget_modify_style(dart->playerEvent[1], dart->scoreBg);
		}
		else {
			gtk_widget_modify_style(dart->playerEvent[1], dart->selectScoreBg);
			
			gtk_widget_modify_style(dart->playerEvent[0], dart->scoreBg);
		}
		gtk_widget_hide_all(dart->mprWindow);
		dart->dartBoard.unpause();
		
	}
	return TRUE;
}
